OpenTTD Source: NWidgetSmallmapDisplay Class Reference

OpenTTD Source 14.0-beta1

Public Member Functions | Private Attributes
NWidgetSmallmapDisplay Class Reference

Custom container class for displaying smallmap with a vertically resizing legend panel. More...

Inheritance diagram for NWidgetSmallmapDisplay:

## Public Member Functions
void | SetupSmallestSize (Window *w) override
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
void | AdjustPaddingForZoom () override
void | Add (std::unique_ptr< NWidgetBase > &&wid)
| Append widget wid to container. More...
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
void | Draw (const Window *w) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Private Attributes
const SmallMapWindow * | smallmap_window
| Window manager instance.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...
Protected Attributes inherited from NWidgetContainer
std::vector< std::unique_ptr< NWidgetBase > > | children
| Child widgets in contaier.

## Detailed Description

Custom container class for displaying smallmap with a vertically resizing legend panel.

The legend panel has a smallest height that depends on its width. Standard containers cannot handle this case.

Note
  The container assumes it has two children, the first is the display, the second is the bar with legends and selection image buttons. Both children should be both horizontally and vertically resizable and horizontally fillable. The bar should have a minimal size with a zero-size legends display. Child padding is not supported.

Definition at line 1846 of file smallmap_gui.cpp.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetSmallmapDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inlineoverridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1873 of file smallmap_gui.cpp.

## ◆ SetupSmallestSize()

void NWidgetSmallmapDisplay::SetupSmallestSize | ( | Window * | w | ) |
| inlineoverridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1854 of file smallmap_gui.cpp.

References NWidgetContainer::children, NWidgetBase::fill_x, NWidgetBase::fill_y, SmallMapWindow::GetLegendHeight(), SmallMapWindow::GetMinLegendWidth(), SmallMapWindow::min_number_of_columns, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, and smallmap_window.

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp